module CodingTest where

import Data.Char(ord)
import Coding

-- String in Bytes konvertieren
strToBytes :: String-> [Byte]
strToBytes []     = []
strToBytes (c:cs) = toEnum (ord c): strToBytes cs

-- Testtreiberfunktion
testEnc :: Encoding-> String-> String-> String
testEnc enc i o 
  | r == o = "Test "++ i++ " passed."
  | otherwise = "Test "++ i++": Expected "++ o++ ", got "++ r
     where r = encode enc (strToBytes i)

main = do
  putStrLn (testEnc Base32 "f" "MY======")
  putStrLn (testEnc Base32 "fo" "MZXQ====")
  putStrLn (testEnc Base32 "foo" "MZXW6===")
  putStrLn (testEnc Base32 "foob" "MZXW6YQ=")
  putStrLn (testEnc Base32 "fooba" "MZXW6YTB")
  putStrLn (testEnc Base32 "foobar" "MZXW6YTBOI======")

  putStrLn (testEnc Base64 "f" "Zg==")
  putStrLn (testEnc Base64 "fo" "Zm8=")
  putStrLn (testEnc Base64 "foo" "Zm9v")
  putStrLn (testEnc Base64 "foob" "Zm9vYg==")
  putStrLn (testEnc Base64 "fooba" "Zm9vYmE=")
  putStrLn (testEnc Base64 "foobar" "Zm9vYmFy")
  
